/*
** Header file for general purpose file i/o routines.
** (c) Rocco Loscalzo, 1992.
*/

#ifndef      _RFILEIO_

#define      _RFILEIO_

#define      NOT_READ      0        /* Constants for use with op(en)file */
#define      READ          1
#define      NOT_WRITE     0
#define      WRITE         1

#define      NORMAL        0x00     /* File attribute mode constants for mkfile */
#define      READ_ONLY     0x01
#define      HIDDEN        0x02
#define      SYSTEM        0x04
#define      VOLUME        0x08
#define      DIRECTORY     0x10
#define      ARCHIVE       0x20

#define      FILE_EXISTS   0        /* Constants for chkfile */
#define      OK_FOR_WRITE  1

typedef struct                      /* Structure for findfirst/findnext */
{
        char         reserved[21];
        char         attrib;
        unsigned int wr_time;
        unsigned int wr_date;
        long         size;
        char         fname[13];
}       FIND_T;

int    opfile   ( int *handle, char *fname, int read, int write );
int    clfile   ( int handle );
void   ferr     ( int handle );
int    rdfile   ( int handle, int bytes, char *buffer, int *nread );
int    wtfile   ( int handle, int bytes, char *buffer, int *nwrite );
int    mkfile   ( int *handle, char *fname, int attribute );
int    delfile  ( char *fname );
int    findfirst( char *spec, char *fname );
int    findnext ( char *fname );
int    chkfile  ( char *fpath, int mode );
int    renfile  ( char *oldname, char *newname );
long   diskfree ( char drive );
long   filelen  ( int handle );
int    fileseek ( int handle, long fpos );
int    fileseekr( int handle, long fpos );
long   filepos  ( int handle );
void   mktad    ( unsigned int dt, unsigned int tm, char *string );

#endif
