/*==================================================================*/
/*                                                                  */
/*    RGENRL.H - Standard header for general odds & sods macros.    */
/*                                                                  */
/*==================================================================*/

#ifndef       _RGENRL_

#define       _RGENRL_

#ifndef       NULL
#define       NULL              0x00L
#endif

#ifndef       FALSE
#define       FALSE             0x00
#define       TRUE              0x01
#endif

typedef       unsigned char     BYTE;
typedef       unsigned int      WORD;
typedef       unsigned long     DWORD;

#ifndef       MK_FP
#define       MK_FP(s,o)     ( (void far *) ((((DWORD)(s))<<16L) | ((DWORD)(o))) )
#endif

#ifndef       FP_SEG
#define       FP_SEG(fp)     ( (WORD) (((DWORD)(fp))>>16L) )
#define       FP_OFF(fp)     ( (WORD) ((DWORD)(fp)) )
#endif

#define       ABS(x)         ( ( (x) >= 0 ) ? (x) : -(x) )

#define       MIN(x,y)       ( ( (x) < (y) ) ? (x) : (y) )
#define       MAX(x,y)       ( ( (x) > (y) ) ? (x) : (y) )

#define       SETBIT(x,bit)  ( (x) | (0x01<<(bit)) )
#define       CLRBIT(x,bit)  ( (x) & ~(0x01<<(bit)) )
#define       CHKBIT(x,bit)  ( (x) & (0x01<<(bit)) )

#define       CAST(ntype,ostruc) ( *( (ntype *) &ostruc )

#define       BPEEK(s,o)     ( *( (BYTE  *) MK_FP((s),(o))) )
#define       WPEEK(s,o)     ( *( (WORD  *) MK_FP((s),(o))) )
#define       DPEEK(s,o)     ( *( (DWORD *) MK_FP((s),(o))) )

#define       BPOKE(s,o,b)   ((*( (BYTE  *) MK_FP((s),(o))) = (b) ) )
#define       WPOKE(s,o,b)   ((*( (WORD  *) MK_FP((s),(o))) = (b) ) )
#define       DPOKE(s,o,b)   ((*( (DWORD *) MK_FP((s),(o))) = (b) ) )

#define       ZERO(x)        ( memset( (char *)(x), 0x00, sizeof((x)) ) )

/*     General purpose hex/string conversion functions      */

unsigned long hextol         ( char *string );
unsigned int  hextoi         ( char *string );
char          *itohex        ( unsigned int num, char *buffer );
char          *ltohex        ( unsigned long num, char *buffer );


/*     Interrupt driven timer support                       */

int           enable_timers  ( unsigned int rate );
int           disable_timers ( void );
int           set_timer_rate ( unsigned int rate );
int           set_timer_hooks( void (*fasthook)(void), void(*slowhook)(void) );


/*     General purpose character/string conversions         */

char          uppercase      ( char ch );
char          lowercase      ( char ch );
char          *ucase         ( char *string );
char          *lcase         ( char *string );


/*     Odds & sods!     */

unsigned int  cputype        ( void );
void          randomize      ( void );
unsigned int  random         ( void );

void          sleep          ( int secs );
void          waitticks      ( int ticks );

void          *normalizefp   ( void *ptr );

char          *juststr       ( char *string, int len );

/*     These function prototypes have variable parameters -
       the last parameter MUST be NULL!!!
*/

char          *strcatx       ( char *des, const char *src, ... );
char          *strsetx       ( char *des, const char *src, ... );

#endif
