/*==================================================================*/
/*                                                                  */
/*    RMEM.H - Header file for extended/expanded memory support.    */
/*                                                                  */
/*==================================================================*/

#ifndef       _RMEM_

#define       _RMEM_

#ifndef       NULL
#define       NULL              0x00L
#endif

#ifndef       FALSE
#define       FALSE             0x00
#define       TRUE              0x01
#endif

/*  Expanded memory functions (EMS)  */

int           ems_loaded ( void );
int           ems_status ( void );
unsigned int  ems_seg    ( void );
void          ems_pages  ( int *total, int *avail );
int           ems_alloc  ( int pages );
int           ems_map    ( int handle, int page, int logicalpage );
void          ems_free   ( int handle );
char *        ems_version( char *ver );

/*  Extended memory functions (XMS)  */

unsigned int  xms_size( void );
int           xms_move( unsigned long dest, unsigned long src, unsigned int words );

#define       XMS_START            0x100000L
#define       MAP_PHYSICAL(s)      (((long)FP_SEG(s)<<4)+FP_OFF(s))

#endif
