/*
** General purpose 'sound' control functions.
** (c) Rocco Loscalzo, 1992.
*/

#ifndef  _RSOUND_

#define  _RSOUND_

#ifndef  OFF
#define  OFF             0x00
#define  ON              0x01
#endif

#ifndef  NULL
#define  NULL            0x00L
#endif

#define  SLOW_TICK       18
#define  MED_TICK        36
#define  HIGH_TICK       72
#define  FAST_TICK       144

#define  MAXTONES        16370
#define  CONTINUOUS      0

typedef  struct                       /* Structure for tones/beeps */
{
         int freq;                    /* Frequency in Hz of tone   */
         int durtn;                   /* Duration of tone in ticks */
}        TONE;

int      enable_sound     ( unsigned int ntones, int tickrate );
int      disable_sound    ( void );
int      free_sound       ( void );
int      set_sound_rate   ( int tickrate );
int      flush_sounds     ( void );
int      hold_sound       ( int hold );
int      stop_sound       ( void );
int      sound_tone       ( int freq, int durtn );
int      sound_effect     ( TONE *array, int items, int reps );
int      sound_warble     ( int freq1, int dur1, int freq2, int dur2, int reps );
int      sound_slide      ( int sfreq, int ffreq, int durtn, int change, int reps );
int      sound_ticks      ( unsigned int millisecs );
int      load_sfx         ( TONE **effect, char *path );

#define  sound_pause( durtn )                       sound_tone  ( 0, (durtn) )
#define  sound_pulse( freq, durtn, pdurtn, reps )   sound_warble( (freq), (durtn), 0, (pdurtn), (reps) )

#endif
