/*===================================*/
/*                                   */
/*  Sample Demo - (c) RocSoft, 1994  */
/*                                   */
/*===================================*/

#include <rgenrl.h>
#include <rgraph.h>
#include <rsprite.h>
#include <rinout.h>
#include <rfileio.h>
#include <rsound.h>
#include <rblast.h>

#include <string.h>
#include <malloc.h>

#define  SAMPLE_RATE      8000         /*  Sample rate for SFX files  */

char     *Banner   ="\n\r                    Sound Sample Demo (c) RocSoft, 1994.\n\n\r";
char     *Usage    ="Usage:  samples [/SPK] [/SB]\n\r";
char     *Continue ="Press any key to continue";
char     *FileError="Error! Sample files not found!\n";
char     *Instructions="Press any of the following keys:\n\n\rESC - ESCape\n\r1   - Play sample 1\n\r2   - Play sample 2\n\rP   - Pause sound (toggle)\n\r";

void main( int argc, char *argv[] )
{
    int        key, sbflag, spklen1, spklen2, pause=TRUE;
    TONE       *spk1, *spk2;
    RSAMPLE    sb1, sb2;

    prints( Banner,L_GREY,0 );

    if ( argc!=2 )
    {
        prints( Usage,L_GREY,0 );
        return;
    }

    if ( stricmp(argv[1],"/SB")==0 ) sbflag=TRUE; else
      if ( stricmp(argv[1],"/SPK")==0 ) sbflag=FALSE; else
      {
          prints( Usage,L_GREY,0 );
          return;
      }

    if ( sbflag )                /*  Enable sound blaster system  */
    {
        if ( SB_load_sample("LASERZAP.RSB",&sb1) || SB_load_sample("PHASOR.RSB",&sb2) )
        {
            prints( FileError,L_GREY,0 );
            return;
        }
        if ( SB_enable() )
        {
            prints( "SB Card not found!\n",L_GREY,0 );
            return;
        }
    }
    else
    {
        if ( (spklen1=load_sfx(&spk1,"LASERZAP.SFX"))==0 || (spklen2=load_sfx(&spk2,"PHASOR.SFX"))==0 )
        {
            prints( FileError,L_GREY,0 );
            return;
        }
        enable_timers( SAMPLE_RATE );   /*  Speaker system uses timer functions  */
        if ( enable_sound(MAXTONES,SAMPLE_RATE) )
        {
            disable_timers();    /*  MUST do this since we have hooked the timer interrupt!!!  */
            prints( "Error in enabling SPEAKER sound\n",L_GREY,0 );
            return;
        }
    }

    prints( Continue,L_GREY,0 );
    getkey(0);

    cls( L_GREY );
    setpos( 0,0,0 );
    prints( Instructions,L_GREY,0 );
    while ( (key=inkey(0))!=ESCAPEKEY )
    {
        if ( sbflag )
        {
            switch( key )
            {
                case '1':
                  SB_play( &sb1 );      /*  'Current' sample is automatically aborted  */
                  break;
                case '2':
                  SB_play( &sb2 );
                  break;
                case 'p':
                case 'P':
                  pause=SB_pause( pause );
                  break;
            }
        }
        else
        {
            switch( key )
            {
                case '1':
                  flush_sounds();    /*  Clears sound queue  */
                  sound_effect( spk1,spklen1,1 );
                  break;
                case '2':
                  flush_sounds();
                  sound_effect( spk2,spklen2,1 );
                  break;
                case 'p':
                case 'P':
                  pause=hold_sound( pause );
                  break;
            }
        }
    }

    if ( sbflag ) SB_disable(); else
    {
        disable_sound();
        disable_timers();
    }
}
